#ifndef __VT_KFIR_KFIRLIB__
#define __VT_KFIR_KFIRLIB__


// Enums for the initialization steps callback function.
typedef enum VT_KFIR_INIT_STEPS_Tag {
  KF_VXD = 0,
  KF_ALTERA,
  KF_KFIR,
  KF_VIDEO_PROCESSOR,
  KF_I2C,
  KF_ADSP
} VT_KFIR_INIT_STEPS;



typedef enum KFIR_MODE_TAG {
  KFIR_MASTER_MODE = 1,
  KFIR_GENERIC_MODE = 0,
} KFIR_MODE;


#define KFIR_AUDIO_FREQ_SHIFT   5
// Defines for the Revision_ID.
#define KFIR_BOARD_A      0xA
#define KFIR_BOARD_B      0xB
#define KFIR_BOARD_C      0xC
#define KFIR_BOARD_D      0xD


#define KFIR_UNDEFINED_REVISION   0xFFFF

// Defines for the Mask.
#define KFIR_VIDEOPROCESSOR_PARAMS      0x1
#define KFIR_V11_PARAMS                 0x2
#define KFIR_ADSP_PARAMS                0x4

// Do not change this values - MGV 12.05.99 !!!
enum KFIR_M {
  KFIR_I_PICT = 0,
  KFIR_IP_PICT,
  KFIR_IPB_PICT,
  KFIR_IPBB_PICT
};


enum LIBRARY_MODE {KFIR_STOP_MODE , KFIR_PAUSE_MODE , KFIR_RUN_MODE ,KFIR_STILL_MODE , KFIR_PRE_RUN_MODE , KFIR_PRE_STOP_MODE};
enum EVV_PROG {KFIR_FILTER_ENV , KFIR_API_ENV , KFIR_ACTIVEX_ENV  , KFIR_VISUAL_BASIC};



enum VIDEO_PROCESSOR_TYPE {
  PHILLIPS_SAA7113 = 0,
  SAMSUNG_KS0127B
};



// Kfir 3/2 pulldown values.
// Do not change them, they match the values in IDC_3_2_PULDOWN ComboBox.
enum KFIR_3_2_PULLDOWN {
  KFIR_DISABLED = 0,
  KFIR_ENABLED  = 1,
  KFIR_AUTO     = 2
};


enum VT_KFIR_AudioFreq {
  VT_KFIR_AUDIO_FREQ_5_5125 = 0,
  VT_KFIR_AUDIO_FREQ_8_0000 = 1,
  VT_KFIR_AUDIO_FREQ_11_025 = 2,
  VT_KFIR_AUDIO_FREQ_16_000 = 3,
  VT_KFIR_AUDIO_FREQ_22_050 = 4,
  VT_KFIR_AUDIO_FREQ_32_000 = 5,
  VT_KFIR_AUDIO_FREQ_44_100 = 6,
  VT_KFIR_AUDIO_FREQ_48_000 = 7
};

enum PHILIPS_REALTIME_PARAM  {
	PH7113_LUMINANCE_BRIGHTNESS_PARAMETER,
	PH7113_LUMINANCE_CONTRAST_PARAMETER,
	PH7113_CHROMA_SATURATION_PARAMETER,
	PH7113_CHROMA_HUE_CONTROL_PARAMETER
};

enum KFIR_LIBRARY_MODES  {

    FULL_D1,
	 HALF_D1,
	 SIF
};


enum KFIR_HOR_RESOLUTION {
  KFIR_H_160      = 0,  //9
  KFIR_H_320      = 1,  //9,
  KFIR_H_352      = 2,  //2,
  KFIR_H_480      = 3,  //3
  KFIR_H_544      = 4,  //4,
  KFIR_H_640      = 5,  //9,
  KFIR_H_FD1      = 6   //1
};


enum KFIR_VES_ALIGNMENT
{
  KFIR_VES_8      = 0,  //1,
  KFIR_VES_16     = 1,  //2,
  KFIR_VES_32     = 2,  //3,
};

enum KFIR_RATE_CONTROL
{
  KFIR_RATE_CBR                 = 0,
  KFIR_RATE_VBR                 = 1,
  KFIR_RATE_CONST_QUANT_SCALE   = 2,
};



// Kfir parameters.
enum KFIR_FRAME_RATE
{
  KFIR_23_976 = 0,  //1,
  KFIR_24     = 1,  //2,
  KFIR_25     = 2,  //3,
  KFIR_29_97  = 3,  //4,
  KFIR_30     = 4,  //5
};


#define FILE_MODE_STEP            0x20000
#define NTSC_LINES_PER_FIELD	    480/2
#define PAL_LINES_PER_FIELD		 576/2
#define FRAMES_NUMBER						30


// Warning ! Do not change this values !
#define BOARD_REV_B_D   0
#define BOARD_REV_B_D_  1
#define BOARD_REV_E     5
#define BOARD_REV_F     6




enum KFIR_VERT_ROSOLUTION
{
  KFIR_V_112      = 0,  //3,
  KFIR_V_240      = 1,  //2,
  KFIR_V_480      = 2,  //1,  // For NTSC

  KFIR_V_144      = 0,
  KFIR_V_288      = 1,
  KFIR_V_576      = 2,  // for PAL
};


enum VT_KFIR_Aspect_Ratio
{
  VT_KFIR_ASPECT_SQUARE	                = 0,
  VT_KFIR_ASPECT_4_3			= 1,
  VT_KFIR_ASPECT_16_9			= 2,
  VT_KFIR_ASPECT_211_1			= 3
};

enum VT_KFIR_Color_Primaries
{
  VT_KFIR_COLOR_ITUR_709		= 0,
  VT_KFIR_COLOR_UNSPEC			= 1,
  VT_KFIR_COLOR_UNSPECIFIED		= 2,
  VT_KFIR_COLOR_ITUR_624_4M		= 3,
  VT_KFIR_COLOR_ITUR_624_4BG	        = 4,
  VT_KFIR_COLOR_SMPTE_170_M		= 5,
  VT_KFIR_COLOR_SMPTE_240_M		= 6
};

enum VT_KFIR_Trans_Char
{
  VT_KFIR_TRANS_ITUR_709		= 0,
  VT_KFIR_TRANS_UNSPEC			= 1,
  VT_KFIR_TRANS_UNSPECIFIED		= 2,
  VT_KFIR_TRANS_ITUR_624_4M		= 3,
  VT_KFIR_TRANS_ITUR_624_4BG	        = 4,
  VT_KFIR_TRANS_SMPTE_170_M		= 5,
  VT_KFIR_TRANS_SMPTE_240_M		= 6,
  VT_KFIR_TRANS_LINEAR			= 7
};

enum VT_KFIR_Matrix_Coef
{
  VT_KFIR_MATRIX_ITUR_709		= 0,
  VT_KFIR_MATRIX_UNSPEC			= 1,
  VT_KFIR_MATRIX_UNSPECIFIED	        = 2,
  VT_KFIR_MATRIX_FCC			= 3,
  VT_KFIR_MATRIX_ITUR_624_4BG	        = 4,
  VT_KFIR_MATRIX_SMPTE_170_M	        = 5,
  VT_KFIR_MATRIX_SMPTE_240_M	        = 6
};

enum VT_KFIR_IntraDC_Precision
{
  VT_KFIR_PREC_8_BITS			= 0,
  VT_KFIR_PREC_9_BITS			= 1,
  VT_KFIR_PREC_10_BITS			= 2,
  VT_KFIR_PREC_11_BITS			= 3
};

enum VT_KFIR_Frame_Prediction_DCT
{
  VT_KFIR_FIELD_FRAME			= 0,
  VT_KFIR_FRAME				= 1
};


enum VT_KFIR_Intra_VLC_Format
{
  VT_KFIR_B14				= 0,
  VT_KFIR_B15				= 1
};

enum VT_KFIR_Alternate_Scan
{
  VT_KFIR_Zigzag			= 0,
  VT_KFIR_Alternate			= 1
};

enum VT_KFIR_On_Off
{
  VT_KFIR_OFF				= 0,
  VT_KFIR_ON				= 1
};

enum VT_KFIR_VideoSource
{

  VT_KFIR_Composite	= 0,
  VT_KFIR_SVideo = 1,
  VT_KFIR_SERIAL_DIGITAL = 2,
  VT_KFIR_Component = 2,
  VT_KFIR_FILE = 3
};









typedef struct  __VT_KFIR_runtime__
{
	DWORD GOP;
	DWORD Frame;
	DWORD PictType;
	QWORD Picture;

	QWORD StreamLength;
	QWORD AudioStreamLength;
	long  EventType;
	DWORD	WritePtr;
	DWORD	ReadPtr;

	DWORD *ptFirstFreeAudio;
	DWORD *ptFirstFreeVideo;

	int BITRATECURR;
	bool Auto_2_3_PullDown;
	bool SceneChanged;

	DWORD ActualSize;

} VT_KFIR_RunTime;





enum VT_KFIR_VideoFormat
{
  VT_KFIR_NTSC				= 0,
  VT_KFIR_PAL				= 1
};

enum VT_KFIR_AudioMode
{
  VT_KFIR_MONO				= 0,
  VT_KFIR_STEREO			= 1,
  VT_KFIR_DUAL				= 2,
  VT_KFIR_JOINT4_31			= 3,
  VT_KFIR_JOINT8_31			= 4,
  VT_KFIR_JOINT12_31			= 5,
  VT_KFIR_JOINT16_31			= 6
};

enum VT_KFIR_AudioFormat
{
  VT_KFIR_LAYER_I			= 0,
  VT_KFIR_LAYER_II			= 1
};

enum VT_KFIR_StreamType
{
  VT_KFIR_AUDIO_ES			= 0,
  VT_KFIR_VIDEO_ES			= 1,
  VT_KFIR_A_V_ES			= 2,
  VT_KFIR_PROGRAM			= 3,
  VT_KFIR_TRANSPORT			= 4,
  VT_KFIR_PACKET_VES = 5,
  VT_KFIR_PACKET_AES = 6,
  VT_KFIR_SYSTEM = 7
};


enum VT_KFIR_TypesEvent
{
  VT_KFIR_USER_AUDIO = 1,
  VT_KFIR_USER_VIDEO = 2,
  VT_KFIR_USER_ERR_STOP = 4,
  VT_KFIR_USER_TIMEOUT = 8,
	VT_KFIR_USER_START_FALSE=0x10,
	VT_KFIR_USER_FIELD_STORED = 0x20,
  VT_KFIR_USER_BUS_ERR_STOP = 0x40,
	VT_KFIR_USER_STOP_FROM_DRIVER = 0x80
};

enum VT_KFIR_EncodingType
{
	VT_KFIR_PAUSED = 1,
	VT_KFIR_FILEMODE = 2,
	VT_KFIR_LIVEMODE = 4
};

#define KFIR_MIC_DATE_STAMP_LENGTH  32




typedef struct _VT_KFIR_params_  
{
 
  char CompanyName[100];

  enum VT_KFIR_Aspect_Ratio AspectRatio;
  enum VT_KFIR_IntraDC_Precision	IntraDCPrecision;
  enum VT_KFIR_Color_Primaries	ColorPrimaries;
  enum VT_KFIR_Trans_Char TransferCharacteristics;
  enum VT_KFIR_Matrix_Coef	MatrixCoefficients;
  enum VT_KFIR_Frame_Prediction_DCT FramePredictionDCT_I;
  enum VT_KFIR_Frame_Prediction_DCT FramePredictionDCT_B;
  enum VT_KFIR_Frame_Prediction_DCT FramePredictionDCT_P;
  enum VT_KFIR_Intra_VLC_Format IntraVLCFormat_I;
  enum VT_KFIR_Intra_VLC_Format IntraVLCFormat_B;
  enum VT_KFIR_Intra_VLC_Format IntraVLCFormat_P;
  enum VT_KFIR_Alternate_Scan AlternateScan_I;
  enum VT_KFIR_Alternate_Scan AlternateScan_B;
  enum VT_KFIR_Alternate_Scan AlternateScan_P;
  enum VT_KFIR_On_Off ProgressiveSequence;
  enum VT_KFIR_On_Off ProgressiveFrame;
  enum VT_KFIR_On_Off SliceBypass;
  enum VT_KFIR_On_Off VIB_FilterBypass;
  enum VT_KFIR_On_Off VIB_ProgressiveSource;
  enum VT_KFIR_VideoSource Video_Source;
  enum VT_KFIR_VideoFormat Video_Format;
  enum VT_KFIR_AudioMode AudioMode;
  enum VT_KFIR_AudioFormat AudioFormat;
  enum VT_KFIR_AudioFreq AudioFreq;
  WORD AudioBitRate;
  enum VT_KFIR_On_Off AudioCRC;
  enum VT_KFIR_StreamType StreamType;
  WORD TopField;
  WORD Bottom_Field;
  WORD Horiz;
  WORD VBFBufferSize;
  DWORD	BitRate;
  enum VT_KFIR_On_Off EachChunkPTS;

  BYTE VAD_LuminanceFactor;
  BYTE VAD_LuminanceBandPass;
  BYTE VAD_Prefilter;
  BYTE VAD_LuminanceBrightness;
  BYTE VAD_LuminanceContrast;
  BYTE VAD_ChromaSaturation;
  BYTE VAD_HueControl;
  BYTE VAD_ChromLowPass;
  BYTE VAD_ChromCombFilterOff;
  BYTE VAD_ColorStandard;
  BYTE VAD_Dithering;
  BYTE VAD_ChromInterFilter;
  
	WORD		AudioStreamID;
  WORD		VideoStreamID;
  WORD		AudioProgramID;
  WORD		VideoProgramID;
  WORD		ProgramMapID;
  DWORD*	AudioBase;
  DWORD*	VideoBase;
  DWORD   VideoBufferSize;
	DWORD   AudioBufferSize;
	DWORD		VideoEventSize;
	DWORD		AudioEventSize;
  //HANDLE  Event;
	DWORD		SeqStart;
  WORD		FileMode;
	DWORD*	FileModeBuffer;
	DWORD		FieldSize;
	DWORD		FileModeBufferSize;
	DWORD		FileModeStep;
	DWORD		FromFrame;
	DWORD		ToFrame;
	DWORD		FlFileDMA;
	DWORD		TransportRate;
	BYTE		PATVersion;
	DWORD		InitialVideoPTS;
	DWORD		InitialVideoDTS;
	DWORD		InitialAudioPTS;
	DWORD		InitialAudioDTS;
	WORD		ProgramNumber;
	WORD		TransportStreamID;
  char *  ptCurrentDir;
  //  char    FramePath[ KFIR_FILE_LENGTH ];
  //  char    EncodeFileName[ KFIR_FILE_LENGTH ];

  enum VT_KFIR_EncodingType	EncodingType;

	bool	  FlCloseCaption; // close caption added
  bool    FlCloseCaptionGOP;
  bool    FlFieldSwap;

  // Added for the VTR controller
	//HANDLE	VSyncEvent;
  bool    FlClipMode;
  bool    FlAviFileMode;

// New parameters for the KFIR below ---------------------

  // Kfir Ext parameters.
  enum KFIR_FRAME_RATE KF_FrameRate;
  enum KFIR_HOR_RESOLUTION KF_HorResolution;
  enum KFIR_VERT_ROSOLUTION KF_VertResolution;
  enum KFIR_VES_ALIGNMENT KF_VESAlignment;
  enum KFIR_RATE_CONTROL KF_RateControl;
  WORD KF_QuantScale;
  WORD KF_GOP_N;
  enum KFIR_M KF_GOP_M;
  bool KF_TopFiledFirst;
  bool KF_SIF_PictureBottomField;
  bool KF_LowDelay;
  bool KF_LowSearchRange;
  bool KF_Auto_3_2_PullDown;
  DWORD KF_Threshold;
  bool KF_Copyright;
  bool KF_Original;
  DWORD KF_MaxVideoPesSize;
  DWORD KF_MaxAudioPesSize;
  DWORD KF_AudioMissLatency;
  DWORD	KF_MaxBitRate;
  DWORD KF_MinBitRate;
  WORD KF_Convergency;
  KFIR_MODE KF_Mode;
  bool KF_Mpeg_I;
  WORD KF_FrameSkipRatio;
  enum KFIR_3_2_PULLDOWN KF_3_2_PullDown;

  // Kfir Filtering parameters.
  bool KF_HorLuminFilter;
  int KF_HorLuminFiltC0;
  int KF_HorLuminFiltC1;
  int KF_HorLuminFiltC2;
  int KF_HorLuminFiltC3;
  int KF_HorLuminFiltC4;
  int KF_HorLuminFiltC5;
  int KF_HorLuminFiltC6;
  
  bool KF_HorChromaFilter;
  int KF_HorChromaFiltC0;
  int KF_HorChromaFiltC1;
  int KF_HorChromaFiltC2;
  int KF_HorChromaFiltC3;
  int KF_HorChromaFiltC4;
  int KF_HorChromaFiltC5;
  int KF_HorChromaFiltC6;
    
  bool KF_VertChromaTopFilter;
  int KF_VertChromaTopFiltCenter;
  int KF_VertChromaTopFiltC0;
  int KF_VertChromaTopFiltC1;
  int KF_VertChromaTopFiltC2;
  int KF_VertChromaTopFiltC3;
  int KF_VertChromaTopFiltC4;
  int KF_VertChromaTopFiltC5;
  
  bool KF_VertChromaBottomFilter;
  int KF_VertChromaBottomFiltCenter;
  int KF_VertChromaBottomFiltC0;
  int KF_VertChromaBottomFiltC1;
  int KF_VertChromaBottomFiltC2;
  int KF_VertChromaBottomFiltC3;
  int KF_VertChromaBottomFiltC4;
  int KF_VertChromaBottomFiltC5;
  
  WORD Device_ID;
  BYTE Revision_ID;
  WORD Subsystem_ID;

  DWORD KF_MajorVersion;
  DWORD KF_MinorVersion;
  char KF_MicroCodeDateStamp[ KFIR_MIC_DATE_STAMP_LENGTH ];
  BOOL DisableWriteFile;
  char reserved[1000];




} VT_KFIR_CParams;


typedef  BOOL   (*_VT_KFIR_Start)(BOOL,WORD brdnum);
typedef  BOOL   (*_VT_KFIR_Stop)(WORD brdnum );
typedef  BOOL   (*_VT_KFIR_Pause)(WORD brdnum);
typedef  BOOL   (*_VT_KFIR_IsRunning)(WORD brdnum); 
typedef  int    (*_KfGetBoardsNumber)( void );
typedef  void   (*_VT_KFIR_Write)(WORD Reg, WORD Val,WORD brdnum); 
typedef  WORD   (*_VT_KFIR_Read )(WORD Reg,WORD brdnum); 
typedef     void (*_VT_ALTERA_Write)(WORD Reg, WORD Val,WORD brdnum) ;
typedef     DWORD (*_VT_ALTERA_Read)(WORD Reg,WORD brdnum);
typedef     void (*_VT_PLX_Write)(WORD Reg, WORD Val,WORD brdnum) ;
typedef     DWORD (*_VT_PLX_Read)(WORD Reg,WORD brdnum);

#endif
